Index: palm/trunk/SCRIPTS/.palm.config.crayh
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.crayh	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.config.crayh	(revision 2834)
@@ -6,5 +6,5 @@
 %base_directory      $HOME/palm/current_version
 %source_path         $HOME/palm/current_version/trunk/SOURCE
-%user_source_path    $base_directory/JOBS/$fname/USER_CODE
+%user_source_path    $base_directory/JOBS/$jobname/USER_CODE
 %fast_io_catalog     /gfs2/work/niksiraa
 %local_jobcatalog    /home/raasch/job_queue
Index: palm/trunk/SCRIPTS/.palm.config.default
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.config.default	(revision 2834)
@@ -6,5 +6,5 @@
 %base_data         ~/palm/current_version/JOBS
 %source_path       $HOME/palm/current_version/trunk/SOURCE
-%user_source_path  $base_directory/JOBS/$fname/USER_CODE
+%user_source_path  $base_directory/JOBS/$jobname/USER_CODE
 #
 %local_ip            <replace by your computers IP address>
Index: palm/trunk/SCRIPTS/.palm.config.default.in
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default.in	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.config.default.in	(revision 2834)
@@ -13,5 +13,5 @@
 %base_data           @CMAKE_INSTALL_PREFIX@/JOBS
 %source_path         @CMAKE_INSTALL_PREFIX@/trunk/SOURCE
-%user_source_path    @CMAKE_INSTALL_PREFIX@/JOBS/$fname/USER_CODE
+%user_source_path    @CMAKE_INSTALL_PREFIX@/JOBS/$jobname/USER_CODE
 %fast_io_catalog     @CMAKE_INSTALL_PREFIX@/tmp
 %local_jobcatalog    @CMAKE_INSTALL_PREFIX@/job_queue
Index: palm/trunk/SCRIPTS/.palm.config.idefix
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.idefix	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.config.idefix	(revision 2834)
@@ -10,8 +10,8 @@
 %fast_io_catalog    /work/<replace_by_your_IDEFIX_username>
 %local_jobcatalog   $HOME/job_queue
-%output_path        /work/<replace_by_your_IDEFIX_username>/JOBS/$fname
+%output_path        /work/<replace_by_your_IDEFIX_username>/JOBS/$jobname
 %remote_jobcatalog  $HOME/job_queue
 %source_path        $HOME/palm/current_version/trunk/SOURCE
-%user_source_path   $base_directory/JOBS/$fname/USER_CODE
+%user_source_path   $base_directory/JOBS/$jobname/USER_CODE
 #
 %local_ip            130.75.105.239
Index: palm/trunk/SCRIPTS/.palm.config.imuk
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.imuk	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.config.imuk	(revision 2834)
@@ -7,5 +7,5 @@
 %fast_io_catalog   /localdata/raasch
 %source_path       $HOME/palm/current_version/trunk/SOURCE
-%user_source_path  $base_directory/JOBS/$fname/USER_CODE
+%user_source_path  $base_directory/JOBS/$jobname/USER_CODE
 #
 %local_ip            130.75.105.103
Index: palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- palm/trunk/SCRIPTS/.palm.iofiles	(revision 2825)
+++ palm/trunk/SCRIPTS/.palm.iofiles	(revision 2834)
@@ -1,67 +1,67 @@
 #
-#-------------------------------------------------------------------------------------------
+#---------------------------------------------------------------------------------------------
 # List of input-files
-#-------------------------------------------------------------------------------------------
-PARIN                    in:tr      d3#      $base_data/$fname/INPUT          _p3d*
-PARIN                    in:tr      d3r      $base_data/$fname/INPUT          _p3dr*
-PARIN                    in:tr      pcr      $base_data/$fname/INPUT          _pcr*
-TOPOGRAPHY_DATA          inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _topo*
-PIDS_STATIC              inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _static*
-PIDS_DYNAMIC             inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _dynamic*
-rrtmg_lw.nc              inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _rlw
-rrtmg_sw.nc              inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _rsw
-WTM_DATA                 inopt:tr   d3#:d3r  $base_data/$fname/INPUT          _wtm
-BININ                    in:lnpe    d3r:rec  $fast_io_catalog/$fname/RESTART  _d3d*
-PARTICLE_RESTART_DATA_IN in:lnpe    prtr     $fast_io_catalog/$fname/RESTART  _rprt
-DATA_1D_PR_NETCDF        inopt      prr      $base_data/$fname/OUTPUT         _pr*       nc
-DATA_1D_SP_NETCDF        inopt      spr      $base_data/$fname/OUTPUT         _sp*       nc
-DATA_1D_TS_NETCDF        inopt      tsr      $base_data/$fname/OUTPUT         _ts*       nc
-DATA_1D_PTS_NETCDF       inopt      ptsr     $base_data/$fname/OUTPUT         _pts*      nc
-DATA_2D_XY_NETCDF        inopt      xyr      $base_data/$fname/OUTPUT         _xy*       nc
-DATA_2D_XY_AV_NETCDF     inopt      xyr      $base_data/$fname/OUTPUT         _av_xy*    nc
-DATA_2D_XZ_NETCDF        inopt      xzr      $base_data/$fname/OUTPUT         _xz*       nc
-DATA_2D_XZ_AV_NETCDF     inopt      xzr      $base_data/$fname/OUTPUT         _av_xz*    nc
-DATA_2D_YZ_NETCDF        inopt      yzr      $base_data/$fname/OUTPUT         _yz*       nc
-DATA_2D_YZ_AV_NETCDF     inopt      yzr      $base_data/$fname/OUTPUT         _av_yz*    nc
-DATA_3D_NETCDF           inopt      3dr      $base_data/$fname/OUTPUT         _3d*       nc
-DATA_3D_AV_NETCDF        inopt      3dr      $base_data/$fname/OUTPUT         _av_3d*    nc
-DATA_MASK_NETCDF         inopt      mar      $base_data/$fname/OUTPUT         _masked    nc
-DATA_MASK_AV_NETCDF      inopt      mar      $base_data/$fname/OUTPUT         _av_masked nc
-DATA_PRT_NETCDF          inopt:pe   prtr     $base_data/$fname/OUTPUT         _prt*
+#---------------------------------------------------------------------------------------------
+PARIN                    in:tr      d3#      $base_data/$jobname/INPUT          _p3d*
+PARIN                    in:tr      d3r      $base_data/$jobname/INPUT          _p3dr*
+PARIN                    in:tr      pcr      $base_data/$jobname/INPUT          _pcr*
+TOPOGRAPHY_DATA          inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _topo*
+PIDS_STATIC              inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _static*
+PIDS_DYNAMIC             inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _dynamic*
+rrtmg_lw.nc              inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _rlw
+rrtmg_sw.nc              inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _rsw
+WTM_DATA                 inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _wtm
+BININ                    in:lnpe    d3r:rec  $fast_io_catalog/$jobname/RESTART  _d3d*
+PARTICLE_RESTART_DATA_IN in:lnpe    prtr     $fast_io_catalog/$jobname/RESTART  _rprt
+DATA_1D_PR_NETCDF        inopt      prr      $base_data/$jobname/OUTPUT         _pr*       nc
+DATA_1D_SP_NETCDF        inopt      spr      $base_data/$jobname/OUTPUT         _sp*       nc
+DATA_1D_TS_NETCDF        inopt      tsr      $base_data/$jobname/OUTPUT         _ts*       nc
+DATA_1D_PTS_NETCDF       inopt      ptsr     $base_data/$jobname/OUTPUT         _pts*      nc
+DATA_2D_XY_NETCDF        inopt      xyr      $base_data/$jobname/OUTPUT         _xy*       nc
+DATA_2D_XY_AV_NETCDF     inopt      xyr      $base_data/$jobname/OUTPUT         _av_xy*    nc
+DATA_2D_XZ_NETCDF        inopt      xzr      $base_data/$jobname/OUTPUT         _xz*       nc
+DATA_2D_XZ_AV_NETCDF     inopt      xzr      $base_data/$jobname/OUTPUT         _av_xz*    nc
+DATA_2D_YZ_NETCDF        inopt      yzr      $base_data/$jobname/OUTPUT         _yz*       nc
+DATA_2D_YZ_AV_NETCDF     inopt      yzr      $base_data/$jobname/OUTPUT         _av_yz*    nc
+DATA_3D_NETCDF           inopt      3dr      $base_data/$jobname/OUTPUT         _3d*       nc
+DATA_3D_AV_NETCDF        inopt      3dr      $base_data/$jobname/OUTPUT         _av_3d*    nc
+DATA_MASK_NETCDF         inopt      mar      $base_data/$jobname/OUTPUT         _masked    nc
+DATA_MASK_AV_NETCDF      inopt      mar      $base_data/$jobname/OUTPUT         _av_masked nc
+DATA_PRT_NETCDF          inopt:pe   prtr     $base_data/$jobname/OUTPUT         _prt*
 #
-#-------------------------------------------------------------------------------------------
+#---------------------------------------------------------------------------------------------
 # List of output-files
-#-------------------------------------------------------------------------------------------
-BINOUT*                    out:lnpe restart   $fast_io_catalog/$fname/RESTART  _d3d
-PARTICLE_RESTART_DATA_OUT* out:lnpe prt#:prtr $fast_io_catalog/$fname/RESTART  _rprt
+#---------------------------------------------------------------------------------------------
+BINOUT*                    out:lnpe restart   $fast_io_catalog/$jobname/RESTART  _d3d
+PARTICLE_RESTART_DATA_OUT* out:lnpe prt#:prtr $fast_io_catalog/$jobname/RESTART  _rprt
 #
-RUN_CONTROL*               out:tr   d3#:pcr   $base_data/$fname/MONITORING     _rc
-RUN_CONTROL*               out:tra  d3r       $base_data/$fname/MONITORING     _rc
-HEADER*                    out:tr   d3#:pcr   $base_data/$fname/MONITORING     _header
-HEADER*                    out:tra  d3r       $base_data/$fname/MONITORING     _header
-CPU_MEASURES*              out:tr   d3#:pcr   $base_data/$fname/MONITORING     _cpu
-CPU_MEASURES*              out:tra  d3r       $base_data/$fname/MONITORING     _cpu
-PARTICLE_INFO*             out:tr   pt#       $base_data/$fname/MONITORING     _prt_info
-PARTICLE_INFO*             out:tra  ptr       $base_data/$fname/MONITORING     _prt_info
-LIST_PROFIL*               out:tr   d3#       $base_data/$fname/MONITORING     _list_pr
+RUN_CONTROL*               out:tr   d3#:pcr   $base_data/$jobname/MONITORING     _rc
+RUN_CONTROL*               out:tra  d3r       $base_data/$jobname/MONITORING     _rc
+HEADER*                    out:tr   d3#:pcr   $base_data/$jobname/MONITORING     _header
+HEADER*                    out:tra  d3r       $base_data/$jobname/MONITORING     _header
+CPU_MEASURES*              out:tr   d3#:pcr   $base_data/$jobname/MONITORING     _cpu
+CPU_MEASURES*              out:tra  d3r       $base_data/$jobname/MONITORING     _cpu
+PARTICLE_INFO*             out:tr   pt#       $base_data/$jobname/MONITORING     _prt_info
+PARTICLE_INFO*             out:tra  ptr       $base_data/$jobname/MONITORING     _prt_info
+LIST_PROFIL*               out:tr   d3#       $base_data/$jobname/MONITORING     _list_pr
 #
-DATA_1D_PR_NETCDF*         out:tr   *         $base_data/$fname/OUTPUT         _pr        nc
-DATA_1D_SP_NETCDF          out:tr   *         $base_data/$fname/OUTPUT         _sp        nc
-DATA_1D_TS_NETCDF          out:tr   *         $base_data/$fname/OUTPUT         _ts        nc
-DATA_1D_PTS_NETCDF         out:tr   *         $base_data/$fname/OUTPUT         _pts       nc
-DATA_2D_XY_NETCDF*         out:tr   *         $base_data/$fname/OUTPUT         _xy        nc
-DATA_2D_XY_AV_NETCDF*      out:tr   *         $base_data/$fname/OUTPUT         _av_xy     nc
-DATA_2D_XZ_NETCDF*         out:tr   *         $base_data/$fname/OUTPUT         _xz        nc
-DATA_2D_XZ_AV_NETCDF*      out:tr   *         $base_data/$fname/OUTPUT         _av_xz     nc
-DATA_2D_YZ_NETCDF*         out:tr   *         $base_data/$fname/OUTPUT         _yz        nc
-DATA_2D_YZ_AV_NETCDF*      out:tr   *         $base_data/$fname/OUTPUT         _av_yz     nc
-DATA_3D_NETCDF*            out:tr   *         $base_data/$fname/OUTPUT         _3d        nc
-DATA_3D_AV_NETCDF*         out:tr   *         $base_data/$fname/OUTPUT         _av_3d     nc
-DATA_MASK_NETCDF*          out:tr   *         $base_data/$fname/OUTPUT         _masked    nc
-DATA_MASK_AV_NETCDF*       out:tr   *         $base_data/$fname/OUTPUT         _av_masked nc
+DATA_1D_PR_NETCDF*         out:tr   *         $base_data/$jobname/OUTPUT         _pr        nc
+DATA_1D_SP_NETCDF          out:tr   *         $base_data/$jobname/OUTPUT         _sp        nc
+DATA_1D_TS_NETCDF          out:tr   *         $base_data/$jobname/OUTPUT         _ts        nc
+DATA_1D_PTS_NETCDF         out:tr   *         $base_data/$jobname/OUTPUT         _pts       nc
+DATA_2D_XY_NETCDF*         out:tr   *         $base_data/$jobname/OUTPUT         _xy        nc
+DATA_2D_XY_AV_NETCDF*      out:tr   *         $base_data/$jobname/OUTPUT         _av_xy     nc
+DATA_2D_XZ_NETCDF*         out:tr   *         $base_data/$jobname/OUTPUT         _xz        nc
+DATA_2D_XZ_AV_NETCDF*      out:tr   *         $base_data/$jobname/OUTPUT         _av_xz     nc
+DATA_2D_YZ_NETCDF*         out:tr   *         $base_data/$jobname/OUTPUT         _yz        nc
+DATA_2D_YZ_AV_NETCDF*      out:tr   *         $base_data/$jobname/OUTPUT         _av_yz     nc
+DATA_3D_NETCDF*            out:tr   *         $base_data/$jobname/OUTPUT         _3d        nc
+DATA_3D_AV_NETCDF*         out:tr   *         $base_data/$jobname/OUTPUT         _av_3d     nc
+DATA_MASK_NETCDF*          out:tr   *         $base_data/$jobname/OUTPUT         _masked    nc
+DATA_MASK_AV_NETCDF*       out:tr   *         $base_data/$jobname/OUTPUT         _av_masked nc
 #
-DATA_PRT_NETCDF*           out:pe   *         $base_data/$fname/OUTPUT         _prt
-DATA_PRT_NETCDF*           out:trpe *         $base_data/$fname/OUTPUT         _prt
-PARTICLE_DATA*             out:lnpe *         $base_data/$fname/OUTPUT         _prt_dat
+DATA_PRT_NETCDF*           out:pe   *         $base_data/$jobname/OUTPUT         _prt
+DATA_PRT_NETCDF*           out:trpe *         $base_data/$jobname/OUTPUT         _prt
+PARTICLE_DATA*             out:lnpe *         $base_data/$jobname/OUTPUT         _prt_dat
 #
-WTM_OUTPUT_DATA*           out:tr   *         $base_data/$fname/MONITORING     _wtm
+WTM_OUTPUT_DATA*           out:tr   *         $base_data/$jobname/MONITORING     _wtm
Index: palm/trunk/SCRIPTS/palmbuild
===================================================================
--- palm/trunk/SCRIPTS/palmbuild	(revision 2825)
+++ palm/trunk/SCRIPTS/palmbuild	(revision 2834)
@@ -27,4 +27,7 @@
 # -----------------
 # $Id: palmbuild 2718 2018-01-02 08:49:38Z maronga $
+# "fname" renamed to "jobname"
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # Corrected "Former revisions" section
 # 
@@ -113,5 +116,5 @@
  do
    case  $option  in
-       (d)   fname=$OPTARG;;
+       (d)   jobname=$OPTARG;;
        (h)   host_configuration=$OPTARG;;
        (m)   makefile=$OPTARG;;
@@ -126,7 +129,11 @@
 
 
+    # FOR COMPATIBILITY REASONS SET OLD ENVIRONMENT VARIABLE
+ export fname=$jobname
+
+
     # BUILD THE CONFIGURATION-FILE NAME AND THE SOURCES_FOR_RUN-FOLDER NAME
  config_file=.palm.config.$host_configuration
- sources_for_run_catalog=SOURCES_FOR_RUN_${host_configuration}_$fname
+ sources_for_run_catalog=SOURCES_FOR_RUN_${host_configuration}_$jobname
 
 
@@ -482,5 +489,5 @@
 
        # NEXT IS THE BRANCH FOR CREATING THE MAKE_DEPOSITORY_...
-    if [[ "$fname" = "" ]]
+    if [[ "$jobname" = "" ]]
     then
 
@@ -608,5 +615,5 @@
        # INCLUDING E.G. USER-INTERFACE ROUTINES. ALSO ADD OTHER UTILITY EXECUTABLES. EVERYTHING IS
        # COLLECTED IN DIRECTORY SOURCES_FOR_RUN_...
-    elif [[ "$fname" != "" ]]
+    elif [[ "$jobname" != "" ]]
     then
 
@@ -616,5 +623,5 @@
        if [[ $(grep -c "sources for run found" ${host_configuration}_last_make_protocol) != 0  &&  $use_existing_sources_folder = true ]]
        then
-          printf "\a\n  *** compiled sources for run \"$fname\" found on remote host in folder"
+          printf "\a\n  *** compiled sources for run \"$jobname\" found on remote host in folder"
           printf "\n      ${fast_io_catalog}/${sources_for_run_catalog}"
           printf "\n      will be used!"
@@ -697,5 +704,5 @@
        # NEXT IS THE BRANCH FOR CREATING THE MAKE_DEPOSITORY_... ON THE
        # LOCAL HOST
-    if [[ "$fname" = "" ]]
+    if [[ "$jobname" = "" ]]
     then
 
@@ -806,5 +813,5 @@
        if [[ -d ${fast_io_catalog}/${sources_for_run_catalog}  &&  $use_existing_sources_folder = true ]]
        then
-          printf "\a\n  *** compiled sources for run \"$fname\" found on local host in folder"
+          printf "\a\n  *** compiled sources for run \"$jobname\" found on local host in folder"
           printf "\n      ${fast_io_catalog}/${sources_for_run_catalog}"
           printf "\n      will be used!"
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 2825)
+++ palm/trunk/SCRIPTS/palmrun	(revision 2834)
@@ -27,4 +27,7 @@
 # -----------------
 # $Id: palmrun 2718 2018-01-02 08:49:38Z maronga $
+# "fname" renamed to "jobname"
+# 
+# 2718 2018-01-02 08:49:38Z maronga
 # parameters are allowed in output commands (OC:)
 # 
@@ -152,5 +155,5 @@
  execution_error=false
  fileconnection_file=trunk/SCRIPTS/.palm.iofiles
- fname=test
+ jobname=test
  global_revision=""
  host_configuration="default"
@@ -238,5 +241,5 @@
        (B)   delete_temporary_catalog=false; prc="$prc -B";;
        (C)   restart_run=true; prc="$prc -C";;
-       (d)   fname=$OPTARG; prc="$prc -d$OPTARG";;
+       (d)   jobname=$OPTARG; prc="$prc -d$OPTARG";;
        (F)   create_jobfile_only=true;;
        (G)   global_revision=$OPTARG; prc="$prc -G'$OPTARG'";;
@@ -330,7 +333,11 @@
 
 
+    # FOR COMPATIBILITY REASONS SET OLD ENVIRONMENT VARIABLE
+ export fname=$jobname
+
+
     # BUILD THE CONFIGURATION-FILE NAME AND THE SOURCES_FOR_RUN-FOLDER NAME
  config_file=.palm.config.$host_configuration
- sources_for_run_catalog=SOURCES_FOR_RUN_${host_configuration}_$fname
+ sources_for_run_catalog=SOURCES_FOR_RUN_${host_configuration}_$jobname
 
 
@@ -1068,5 +1075,5 @@
        eval filename=${pathin_pre[$i]}/${endin_pre[$i]}
     else
-       eval filename=${pathin_pre[$i]}/${fname}${endin_pre[$i]}
+       eval filename=${pathin_pre[$i]}/${jobname}${endin_pre[$i]}
     fi
 
@@ -1100,5 +1107,5 @@
     else
 
-          # FIRST CHECK FOR MULTIPLE NAMES WITH THE SAME BASENAME ($fname) AND
+          # FIRST CHECK FOR MULTIPLE NAMES WITH THE SAME BASENAME ($jobname) AND
           # CREATE A LIST FOR THE DETECTED BASENAME ENDINGS
        if [[ "${multin[$i]}" = true ]]
@@ -1129,7 +1136,7 @@
               fi
 
-                 # remove the fname from the beginning
-              length_fname=${#fname}
-              ending=${basefilename:${length_fname}}
+                 # remove the jobname from the beginning
+              length_jobname=${#jobname}
+              ending=${basefilename:${length_jobname}}
 
                  # remove the ending given in the .iofiles from the beginning
@@ -1193,5 +1200,5 @@
              eval filename=${pathin[$nr_of_input_files]}/${endin[$nr_of_input_files]}
           else
-             eval filename=${pathin[$nr_of_input_files]}/${fname}${endin[$nr_of_input_files]}
+             eval filename=${pathin[$nr_of_input_files]}/${jobname}${endin[$nr_of_input_files]}
           fi
 
@@ -1273,5 +1280,5 @@
                 frelin[$nr_of_input_files]=${endin[$nr_of_input_files]}.$cyclestring
              else
-                frelin[$nr_of_input_files]=${fname}${endin[$nr_of_input_files]}.$cyclestring
+                frelin[$nr_of_input_files]=${jobname}${endin[$nr_of_input_files]}.$cyclestring
              fi
           else
@@ -1280,5 +1287,5 @@
                 frelin[$nr_of_input_files]=${endin[$nr_of_input_files]}
              else
-                frelin[$nr_of_input_files]=${fname}${endin[$nr_of_input_files]}
+                frelin[$nr_of_input_files]=${jobname}${endin[$nr_of_input_files]}
              fi
           fi
@@ -1314,5 +1321,5 @@
        fi
        (( maxcycle = 0 ))
-       eval filename=${pathout_pre[$i]}/${fname}${endout_pre[$i]}
+       eval filename=${pathout_pre[$i]}/${jobname}${endout_pre[$i]}
        eval catalogname=${pathout_pre[$i]}
        if ! ls $filename* 1>/dev/null 2>&1
@@ -1361,5 +1368,5 @@
  then
     run_id=$RANDOM
-    job_id=${fname}.$run_id
+    job_id=${jobname}.$run_id
 
     tempdir=$fast_io_catalog/$job_id
@@ -1605,5 +1612,5 @@
  fi
  printf "|                                                                        | \n"
- column1="base name of files:"; column2=$fname
+ column1="base name of files:"; column2=$jobname
  printf "| %-25s%-45s | \n" "$column1" "$column2"
  column1="activation string list:"; column2=$(echo $activation_string_list)
@@ -1788,5 +1795,5 @@
 
        # NOW CREATE THE SOURCES_FOR_RUN FOLDER
-    palmbuild  -v  $use_existing_sources_folder  -h $host_configuration  -d $fname
+    palmbuild  -v  $use_existing_sources_folder  -h $host_configuration  -d $jobname
 
     if [[ $? != 0 ]]
@@ -2053,5 +2060,5 @@
        # (FILE ENVPAR WILL BE READ BY PALM)
     cat  >  ENVPAR  <<  EOF
- &envpar  run_identifier = '$fname', host = '$host_configuration',
+ &envpar  run_identifier = '$jobname', host = '$host_configuration',
           write_binary = .${write_binary}., tasks_per_node = $tasks_per_node,
           maximum_parallel_io_streams = $maximum_parallel_io_streams,
@@ -2303,5 +2310,5 @@
        then
 
-          eval filename=${pathout[$i]}/${fname}${endout[$i]}
+          eval filename=${pathout[$i]}/${jobname}${endout[$i]}
 
              # DETERMINE THE CYCLE NUMBER
@@ -2445,12 +2452,12 @@
                 transfer_failed=false
                 printf "\n  >>> OUTPUT: ${localout[$i]}$catalog_string  $append_string by SCP to"
-                printf "\n              ${pathout[$i]}/${host_configuration}_${fname}${endout[$i]}$catalog_string\n"
+                printf "\n              ${pathout[$i]}/${host_configuration}_${jobname}${endout[$i]}$catalog_string\n"
 
                    # TRANSFER VIA SCP
                 if [[ "$remote_loginnode" != "" ]]
                 then
-                   echo "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${host_configuration}_${fname}${endout[$i]}  ${extout[$i]}"  |  ssh -q $remote_username@$remote_loginnode
+                   echo "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${host_configuration}_${jobname}${endout[$i]}  ${extout[$i]}"  |  ssh -q $remote_username@$remote_loginnode
                 else
-                   batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${host_configuration}_${fname}${endout[$i]}  ${extout[$i]}
+                   batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${host_configuration}_${jobname}${endout[$i]}  ${extout[$i]}
                 fi
                 [[ $? != 0 ]]  &&  transfer_failed=true
@@ -2461,5 +2468,5 @@
                 then
                    printf "  +++ transfer failed. Trying to save a copy on this host under:\n"
-                   printf "      ${pathout[$i]}/${host_configuration}_${fname}${endout[$i]}_$run_id\n"
+                   printf "      ${pathout[$i]}/${host_configuration}_${jobname}${endout[$i]}_$run_id\n"
 
                       # FIRST CHECK, IF DIRECTORY EXISTS, AND CREATE IT, IF NECESSARY
@@ -2471,5 +2478,5 @@
                       mkdir -p  $local_catalog
                    fi
-                   eval  cp  ${localout[$i]}  ${pathout[$i]}/${host_configuration}_${fname}${endout[$i]}_$run_id
+                   eval  cp  ${localout[$i]}  ${pathout[$i]}/${host_configuration}_${jobname}${endout[$i]}_$run_id
                    transfer_problems=true
                 fi
@@ -2679,5 +2686,5 @@
 
        # BUILD THE PALMRUN-COMMAND TO BE CALLED IN THE BATCH-JOB
-    palmrun_com="$palmrun_script_name -d $fname -h $host_configuration -m $memory -t $cpumax -q $queue -r $run_id -U $local_username"
+    palmrun_com="$palmrun_script_name -d $jobname -h $host_configuration -m $memory -t $cpumax -q $queue -r $run_id -U $local_username"
     [[ "$activation_string_list" != "" ]]  &&  palmrun_com=${palmrun_com}" -a \"$activation_string_list\""
     [[ "$global_revision" != "" ]]  &&  palmrun_com=${palmrun_com}" -G \"$global_revision\""
@@ -2761,5 +2768,5 @@
 
        echo "set -x"                               >>  $jobfile
-       echo "${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote  \"$local_jobcatalog\"  ${host_configuration}_${fname}"  >>  $jobfile
+       echo "${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote  \"$local_jobcatalog\"  ${host_configuration}_${jobname}"  >>  $jobfile
        echo "%%END%%"                              >>  $jobfile
        echo "echo \" *** submitting job for transfering the job protocol file to $local_ip\" "  >>  $jobfile