Index: palm/trunk/SCRIPTS/NCL/cross_sections.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 2834)
+++ palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 2837)
@@ -41,27 +41,20 @@
 ; load .ncl.config or .ncl.config.default
 ;***************************************************
-   
-file_name ="$PALM_BIN/../../.ncl.config"
-existing_file = file_exists(ncl_version_ch,file_name)
-
+
+existing_file = file_exists(ncl_version_ch,file_config)
 if (existing_file) then
-   loadscript("$PALM_BIN/../../.ncl.config")
+   loadscript(file_config)
 else
-   file_name = "$PALM_BIN/NCL/.ncl.config.default"
-   existing_file = file_exists(ncl_version_ch,file_name)
-   if (existing_file) then
-      loadscript( "$PALM_BIN/NCL/.ncl.config.default")
-   else
-      palm_bin_path = getenv("PALM_BIN")
-      print(" ")
-      print("Neither the personal configuration file '.ncl.config' exists in")
-      print("~/palm/current_version")
-      print("nor the default configuration file '.ncl.config.default' "+\
-            "exists in")
-      print(palm_bin_path + "/NCL")
-      print(" ")
-      exit
-   end if
-end if 
+   palm_bin_path = getenv("PALM_BIN")
+   print(" ")
+   print("Neither the personal configuration file '.ncl.config' exists in")
+   print("~/palm/current_version")
+   print("nor the default configuration file '.ncl.config.default' "+\
+         "exists in")
+   print(palm_bin_path + "/NCL")
+   print(" ")
+   exit
+end if
+
 
 begin
Index: palm/trunk/SCRIPTS/NCL/profiles.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 2834)
+++ palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 2837)
@@ -39,27 +39,19 @@
 ; load .ncl.config or .ncl.config.default
 ;***************************************************
-   
-file_name ="$PALM_BIN/../../.ncl.config"
-existing_file = file_exists(ncl_version_ch,file_name)
-
+
+existing_file = file_exists(ncl_version_ch,file_config)
 if (existing_file) then
-   loadscript("$PALM_BIN/../../.ncl.config")
+   loadscript(file_config)
 else
-   file_name = "$PALM_BIN/NCL/.ncl.config.default"
-   existing_file = file_exists(ncl_version_ch,file_name)
-   if (existing_file) then
-      loadscript( "$PALM_BIN/NCL/.ncl.config.default")
-   else
-      palm_bin_path = getenv("PALM_BIN")
-      print(" ")
-      print("Neither the personal configuration file '.ncl.config' exists in")
-      print("~/palm/current_version")
-      print("nor the default configuration file '.ncl.config.default' "+\
-            "exists in")
-      print(palm_bin_path + "/NCL")
-      print(" ")
-      exit
-   end if
-end if 
+   palm_bin_path = getenv("PALM_BIN")
+   print(" ")
+   print("Neither the personal configuration file '.ncl.config' exists in")
+   print("~/palm/current_version")
+   print("nor the default configuration file '.ncl.config.default' "+\
+         "exists in")
+   print(palm_bin_path + "/NCL")
+   print(" ")
+   exit
+end if
 
     
Index: palm/trunk/SCRIPTS/NCL/spectra.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/spectra.ncl	(revision 2834)
+++ palm/trunk/SCRIPTS/NCL/spectra.ncl	(revision 2837)
@@ -39,27 +39,20 @@
 ; load .ncl.config or .ncl.config.default
 ;***************************************************
-   
-file_name ="$PALM_BIN/../../.ncl.config"
-existing_file = file_exists(ncl_version_ch,file_name)
-
+
+existing_file = file_exists(ncl_version_ch,file_config)
 if (existing_file) then
-   loadscript("$PALM_BIN/../../.ncl.config")
+   loadscript(file_config)
 else
-   file_name = "$PALM_BIN/NCL/.ncl.config.default"
-   existing_file = file_exists(ncl_version_ch,file_name)
-   if (existing_file) then
-      loadscript( "$PALM_BIN/NCL/.ncl.config.default")
-   else
-      palm_bin_path = getenv("PALM_BIN")
-      print(" ")
-      print("Neither the personal configuration file '.ncl.config' exists in")
-      print("~/palm/current_version")
-      print("nor the default configuration file '.ncl.config.default' "+\
-            "exists in")
-      print(palm_bin_path + "/NCL")
-      print(" ")
-      exit
-   end if
-end if 
+   palm_bin_path = getenv("PALM_BIN")
+   print(" ")
+   print("Neither the personal configuration file '.ncl.config' exists in")
+   print("~/palm/current_version")
+   print("nor the default configuration file '.ncl.config.default' "+\
+         "exists in")
+   print(palm_bin_path + "/NCL")
+   print(" ")
+   exit
+end if
+
 
 begin
Index: palm/trunk/SCRIPTS/NCL/timeseries.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/timeseries.ncl	(revision 2834)
+++ palm/trunk/SCRIPTS/NCL/timeseries.ncl	(revision 2837)
@@ -40,27 +40,20 @@
 ; load .ncl.config or .ncl.config.default
 ;***************************************************
-   
-file_name ="$PALM_BIN/../../.ncl.config"
-existing_file = file_exists(ncl_version_ch,file_name)
-
+
+existing_file = file_exists(ncl_version_ch,file_config)
 if (existing_file) then
-   loadscript("$PALM_BIN/../../.ncl.config")
+   loadscript(file_config)
 else
-   file_name = "$PALM_BIN/NCL/.ncl.config.default"
-   existing_file = file_exists(ncl_version_ch,file_name)
-   if (existing_file) then
-      loadscript( "$PALM_BIN/NCL/.ncl.config.default")
-   else
-      palm_bin_path = getenv("PALM_BIN")
-      print(" ")
-      print("Neither the personal configuration file '.ncl.config' exists in")
-      print("~/palm/current_version")
-      print("nor the default configuration file '.ncl.config.default' "+\
-            "exists in")
-      print(palm_bin_path + "/NCL")
-      print(" ")
-      exit
-   end if
+   palm_bin_path = getenv("PALM_BIN")
+   print(" ")
+   print("Neither the personal configuration file '.ncl.config' exists in")
+   print("~/palm/current_version")
+   print("nor the default configuration file '.ncl.config.default' "+\
+         "exists in")
+   print(palm_bin_path + "/NCL")
+   print(" ")
+   exit
 end if
+
 
 begin
Index: palm/trunk/SCRIPTS/palmplot
===================================================================
--- palm/trunk/SCRIPTS/palmplot	(revision 2834)
+++ palm/trunk/SCRIPTS/palmplot	(revision 2837)
@@ -19,5 +19,5 @@
 # Current revisions:
 # -----------------
-# 
+# assign configuration file within palmplot call
 # 
 # Former revisions:
@@ -91,5 +91,5 @@
  # CS: cross_sections.ncl PR: profiles.ncl SP: spectra.ncl TS: timeseries.ncl
  # VA: PARAMETERS WHICH CONTAIN LISTS OF VARIABLE NAMES
- STRINGPARAMS_CO="file_1 format_out file_out var "
+ STRINGPARAMS_CO="file_1 format_out file_out var file_config "
  STRINGPARAMS_CS="sort mode fill_mode unit_x unit_y unit_z vec1 vec2 plotvec"
  STRINGPARAMS_PR="file_2 file_3 file_4 file_5 file_6 name_legend_1 name_legend_2 name_legend_3 name_legend_4 name_legend_5 name_legend_6 c_var"
@@ -149,5 +149,17 @@
        value=$PWD/$value
     fi
-     
+
+    # USE CONFIG FILE SPECIFIED BY USER
+    if [ "$key" = "file_config" ]
+    then
+       if [ -f $value ]
+       then
+          use_user_config=true
+       else
+          printf "\n  configuration file \"$value\" not found."
+          printf "\n  trying to use one of the standard configuraion files...\n"
+       fi
+    fi
+
     # PROCESSING STRINGS
     for a in $STRINGPARAMS
@@ -193,11 +205,20 @@
  done
 
+ # SET CONFIGURATION FILE TO ONE OF THE DEFAULT FILES IF NOT SPECIFIED BY USER
+ if [ "$use_user_config" != true ]
+ then
+    key="file_config"
+
+    if [ -f $PALM_BIN/../../.ncl.config ]
+    then
+       value="\"$PALM_BIN/../../.ncl.config\""
+    else
+       value="\"$PALM_BIN/NCL/.ncl.config.default\""
+    fi
+
+    CMDLINE=$CMDLINE"$key=$value "
+ fi
+
  # EXECUTING THE PARTICULAR NCL SCRIPT
  cd $PALM_BIN/NCL
  ncl 'dq=str_get_dq()' $script $CMDLINE 
-
-
-
-
-
-