Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 2847)
+++ palm/trunk/SOURCE/Makefile	(revision 2894)
@@ -25,4 +25,10 @@
 # -----------------
 # $Id$
+# read/write_3d_binary and read/write_var_list has been removed, 
+# read/write_restart_data_mod, wrd_write_string and
+# user_read/write_restart_data_mod has been added, dependencies with respect to 
+# the aforementioned routines have been added/removed
+#
+# 2847 2018-03-02 21:45:58Z suehring
 # Changed format and enforced sorting
 # 
@@ -66,9 +72,9 @@
 # virtual_flight_mod, synthetic_turbulence_generator_mod and
 # wind_turbine_model_mod were added to read_var_list
-# 
+#
 # 2563 2017-10-19 15:36:10Z Giersch
 # wind_turbine_model_mod and synthetic_turbulence_generator_mod were added to
-# write_var_list and virtual_flight_mod was deleted from read_var_list  
-# 
+# write_var_list and virtual_flight_mod was deleted from read_var_list 
+#
 # 2544 2017-10-13 18:09:32Z maronga
 # Added date_and_time_mod 
@@ -533,6 +539,5 @@
 	random_gauss.f90 \
 	random_generator_parallel_mod.f90 \
-	read_3d_binary.f90 \
-	read_var_list.f90 \
+        read_restart_data_mod.f90 \
 	run_control.f90 \
 	set_slicer_attributes_dvrp.f90 \
@@ -585,13 +590,14 @@
 	user_module.f90 \
 	user_parin.f90 \
-	user_read_restart_data.f90 \
+	user_read_restart_data_mod.f90 \
 	user_spectra.f90 \
 	user_statistics.f90 \
+	user_write_restart_data_mod.f90 \
 	uv_exposure_model_mod.f90 \
 	vertical_nesting_mod.f90 \
 	virtual_flight_mod.f90 \
 	wind_turbine_model_mod.f90 \
-	write_3d_binary.f90 \
-	write_var_list.f90
+	wrd_write_string.f90 \
+        write_restart_data_mod.f90
 
 
@@ -625,5 +631,4 @@
 .f90.o:
 	$(F90) $(F90FLAGS) $(COPT) -c $<
-
 
 
@@ -934,4 +939,5 @@
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
+	read_restart_data_mod.o \
 	surface_layer_fluxes_mod.o \
 	surface_mod.o \
@@ -1181,5 +1187,6 @@
 	pmc_interface_mod.o \
 	pmc_particle_interface.o \
-	surface_layer_fluxes_mod.o
+	surface_layer_fluxes_mod.o \
+	write_restart_data_mod.o
 parin.o: \
 	chemistry_model_mod.o \
@@ -1198,4 +1205,5 @@
 	progress_bar_mod.o \
 	radiation_model_mod.o \
+	read_restart_data_mod.o \
 	spectra_mod.o \
 	synthetic_turbulence_generator_mod.o \
@@ -1334,27 +1342,21 @@
 	mod_kinds.o \
 	modules.o
-read_3d_binary.o: \
+read_restart_data_mod.o: \
 	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	mod_kinds.o \
-	modules.o \
+	cpulog_mod.o\
+	land_surface_model_mod.o \
+	microphysics_mod.o \
+	modules.o \
+	mod_kinds.o \
+	model_1d_mod.o \
+	netcdf_interface_mod.o \
 	radiation_model_mod.o \
-	random_function_mod.o \
+	random_function_mod.o\
 	random_generator_parallel_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
-	urban_surface_mod.o
-read_var_list.o: \
-	microphysics_mod.o \
-	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	plant_canopy_model_mod.o \
-	spectra_mod.o \
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
+	user_read_restart_data_mod.o \
 	vertical_nesting_mod.o \
 	virtual_flight_mod.o \
@@ -1631,6 +1633,5 @@
 	modules.o \
 	user_module.o
-user_read_restart_data.o: \
-	mod_kinds.o \
+user_read_restart_data_mod.o: \
 	modules.o \
 	user_module.o
@@ -1644,4 +1645,6 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	user_module.o
+user_write_restart_data_mod.o: \
 	user_module.o
 uv_exposure_model_mod.o: \
@@ -1666,26 +1669,23 @@
 	mod_kinds.o \
 	modules.o
-write_3d_binary.o: \
-	cpulog_mod.o \
-	gust_mod.o \
-	mod_kinds.o \
-	modules.o \
+wrd_write_string.o: \
+	mod_kinds.o
+write_restart_data_mod.o: \
+	chemistry_model_mod.o \
+	land_surface_model_mod.o \
+	microphysics_mod.o \
+	mod_kinds.o \
+	mod_particle_attributes.o \
+	model_1d_mod.o \
+	modules.o \
+	netcdf_interface_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
-	spectra_mod.o \
-	surface_mod.o
-write_var_list.o: \
-	chemistry_model_mod.o \
-	microphysics_mod.o \
-	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	plant_canopy_model_mod.o\
-	spectra_mod.o \
+	spectra_mod.o surface_mod.o \
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
+	user_write_restart_data_mod.o \
 	vertical_nesting_mod.o \
-	virtual_flight_mod.o\
+	virtual_flight_mod.o \
 	wind_turbine_model_mod.o